% Domain   : Syntactic
% Problem  : Choice on relations between individuals and functions
% Refs     : [Bro11] Brown (2011), Email to Geoff Sutcliffe
% Source   : [Bro11]
% Names    : CHOICE12 [Bro11]
% Status   : Theorem
% Comments : THF0 syntax
%          : Choice operators on i and ii are used to define a choice operator on i*ii (Curried).
thf(eps,type,(eps : (($i > $o) > $i))).
thf(choiceax,axiom,(! [P : ($i > $o)] : ((? [X : $i] : (P @ X)) => (P @ (eps @ P))))).
thf(epsii,type,(epsii : ((($i > $i) > $o) > ($i > $i)))).
thf(choiceaxii,axiom,(! [P : (($i > $i) > $o)] : ((? [X : ($i > $i)] : (P @ X)) => (P @ (epsii @ P))))).
thf(epsa,type,(epsa : (($i > (($i > $i) > $o)) > $i))).
thf(epsad,definition,(epsa = (^ [R : ($i > (($i > $i) > $o))] : (eps @ (^ [X : $i] : (? [Y : ($i > $i)] : ((R @ X) @ Y))))))).
thf(epsb,type,(epsb : (($i > (($i > $i) > $o)) > ($i > $i)))).
thf(epsbd,definition,(epsb = (^ [R : ($i > (($i > $i) > $o))] : (epsii @ (^ [Y : ($i > $i)] : ((R @ (epsa @ R)) @ Y)))))).
thf(conj,conjecture,(! [R : ($i > (($i > $i) > $o))] : ((? [X : $i, Y : ($i > $i)] : ((R @ X) @ Y)) => ((R @ (epsa @ R)) @ (epsb @ R))))).


