% Domain   : Syntactic
% Problem  : Choice on binary relations between functions
% Refs     : [Bro11] Brown (2011), Email to Geoff Sutcliffe
% Source   : [Bro11]
% Names    : CHOICE14 [Bro11]
% Status   : Theorem
% Comments : THF0 syntax
%          : A choice operator ii is used to define a choice operator on ii*ii (Curried).
thf(epsii,type,(epsii : ((($i > $i) > $o) > ($i > $i)))).
thf(choiceaxii,axiom,(! [P : (($i > $i) > $o)] : ((? [X : ($i > $i)] : (P @ X)) => (P @ (epsii @ P))))).
thf(epsa,type,(epsa : ((($i > $i) > (($i > $i) > $o)) > ($i > $i)))).
thf(epsad,definition,(epsa = (^ [R : (($i > $i) > (($i > $i) > $o))] : (epsii @ (^ [X : ($i > $i)] : (? [Y : ($i > $i)] : ((R @ X) @ Y))))))).
thf(epsb,type,(epsb : ((($i > $i) > (($i > $i) > $o)) > ($i > $i)))).
thf(epsbd,definition,(epsb = (^ [R : (($i > $i) > (($i > $i) > $o))] : (epsii @ (^ [Y : ($i > $i)] : ((R @ (epsa @ R)) @ Y)))))).
thf(conj,conjecture,(! [R : (($i > $i) > (($i > $i) > $o))] : ((? [X : ($i > $i), Y : ($i > $i)] : ((R @ X) @ Y)) => ((R @ (epsa @ R)) @ (epsb @ R))))).
