% Domain   : Syntactic
% Problem  : Choice Complement
% English  : There is an operator that
%            chooses an element not in the predicate, if there is one.
% Refs     : [Bac10] Backes (2010), Tableaux for Higher-Order Logic with
%            If-Then-Else, Description and Choice. (Master's Thesis)
%          : [Bro11] Brown (2011), Email to Geoff Sutcliffe
% Source   : Section 6.5 of [Bac10]
% Names    : CHOICE25 [Bro11]
% Status   : Theorem
% Comments : THF0 syntax
thf(choicecomp,conjecture,(? [E : (($i > $o) > $i)] : (! [P : ($i > $o)] : ((? [X : $i] : (~ (P @ X))) => (~ (P @ (E @ P))))))).


